
/* list.h - headers for list.c
 */

/* $Id: list.h,v 1.7 1999/06/14 10:23:22 liff Exp $ */

/* 
 * $Log: list.h,v $
 * Revision 1.7  1999/06/14 10:23:22  liff
 * Added add_list_to_list.
 * I didn't need it tho :)
 *
 * Revision 1.6  1999/05/14 07:14:45  pht
 *
 * you can now do 'make indent' :>
 *
 * Revision 1.5  1999/05/13 19:32:26  steven
 * added functions to add to a sorted list (list.c list.h)
 * added functions to handle time hooks (hook.c hook.h)
 * modified core.c to test
 * made #define for channel and server to join :p
 * (because I'm lazy to always find it and change it)
 *
 * Revision 1.4  1999/05/11 15:52:41  steven
 * changed *.h so they can be #included several times
 * (with #ifndef and stuff)
 *
 * Revision 1.3  1999/05/07 00:24:47  pht
 *
 * Id/Log-ized.
 *
 * Revision 1.2  1999/05/07 00:19:44  pht
 *
 * Testing $Id: list.h,v 1.7 1999/06/14 10:23:22 liff Exp $ (yea, i'm lame yet)
 *
 */
#ifndef __LIST_H__
#define __LIST_H__
#include <sys/types.h>

typedef struct list_t
{
    char *name;
    int id;
    struct list_t *next, *prev;
}
List;

extern List *add_to_list(List ** first, List ** last, size_t size, char *name,
			 int id);

List *add_list_to_list(List *l1, List *l2);
extern List *add_to_id_sorted_list(List ** first, List ** last, size_t size,
			 char *name, int id, int cmp_func(int a, int b));

extern List *add_to_name_sorted_list(List ** first, List ** last, size_t size,
	 char *name, int id, int cmp_func(const char *a, const char *b));

extern void remove_from_list(List ** first, List ** last, List * p);

extern List *find_in_list_by_name(List * first, char *name,
			     int cmp_func(const char *a, const char *b));

extern List *find_in_list_by_id(List * first, int id,
				int cmp_func(int a, int b));

#endif				/* __LIST_H__ */
