
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "misc.h"

int qmatch (char *ptr1,char *ptr2)
{
 return irc_equal(ptr1,ptr2);
}

char *strlwr(char *str)
{
    if (str)
    {
	while (*str)
	{
	    switch (*str)
	    {
		case '{':
		    *str = '[';
		    break;
		case '}':
		    *str = ']';
		    break;
		case '|':
		    *str = '\\';
		    break;
		case '^':
		    *str = '~';
		    break;
		default:
		    *str = tolower(*str);
	    }
	    str++;
	}
    }
	
    return str;
    
}

/* compares mask to real string -- ripped from irc II :) */
/* thanks to pht for this wonderful function */
int irc_equal(char *real, char *mask)
{
    char *realp, *maskp;

    realp=real;
    maskp=mask;

    while (*realp && *maskp && (*maskp != '*'))
    {
        if (*maskp == '?' || (*realp == *maskp))
            maskp++, realp++;
        else
            break;
    }

    if (*maskp == '*')
    {
        maskp++;

        while (*realp)
        {
            if (irc_equal(realp, maskp))
                return 1;
            else
                realp++;
        }
    }

    if (!*realp && !*maskp)
        return 1;

    return 0;
}
